com.google.gwt.i18n.shared

## Interface DateTimeFormatInfo

- All Known Subinterfaces:
    DateTimeFormatInfo
  All Known Implementing Classes:
    DateTimeFormatInfoAdapter, DefaultDateTimeFormatInfo, DefaultDateTimeFormatInfo

      public interface DateTimeFormatInfo

  Information required for formatting and parsing localized date/time values.

  Implementors should subclass `DefaultDateTimeFormatInfo` so when methods are added they will get reasonable defaults and not break. See the same class for example values returned by these methods.

- - ### Method Summary

    All Methods Instance Methods Abstract Methods
    Modifier and Type | Method and Description
    --- | ---
    `java.lang.String[]` | `ampms()` Returns array of strings containing abbreviations for Ante Meridiem and Post Meridiem.
    `java.lang.String` | `dateFormat()` Returns a safe default date format.
    `java.lang.String` | `dateFormatFull()` Returns a "full" date format.
    `java.lang.String` | `dateFormatLong()` Returns a "long" date format.
    `java.lang.String` | `dateFormatMedium()` Returns a "medium" date format.
    `java.lang.String` | `dateFormatShort()` Returns a "short" date format.
    `java.lang.String` | `dateTime(java.lang.String timePattern, java.lang.String datePattern)` Returns a date/time format from a date format pattern and a time format pattern, using the locale default joining.
    `java.lang.String` | `dateTimeFull(java.lang.String timePattern, java.lang.String datePattern)` Returns a date/time format from a date format pattern and a time format pattern, using "full" joining.
    `java.lang.String` | `dateTimeLong(java.lang.String timePattern, java.lang.String datePattern)` Returns a date/time format from a date format pattern and a time format pattern, using "full" joining.
    `java.lang.String` | `dateTimeMedium(java.lang.String timePattern, java.lang.String datePattern)` Returns a date/time format from a date format pattern and a time format pattern, using "full" joining.
    `java.lang.String` | `dateTimeShort(java.lang.String timePattern, java.lang.String datePattern)` Returns a date/time format from a date format pattern and a time format pattern, using "full" joining.
    `java.lang.String[]` | `erasFull()` Returns an array of the full era names.
    `java.lang.String[]` | `erasShort()` Returns abbreviations of the era names.
    `int` | `firstDayOfTheWeek()` Returns the day which generally comes first in a weekly calendar view, as an index into the return value of `weekdaysFull()`.
    `java.lang.String` | `formatDay()` Returns localized format equivalent to the "d" skeleton pattern.
    `java.lang.String` | `formatHour12Minute()` Returns localized format equivalent to the "hm" skeleton pattern.
    `java.lang.String` | `formatHour12MinuteSecond()` Returns localized format equivalent to the "hms" skeleton pattern.
    `java.lang.String` | `formatHour24Minute()` Returns localized format equivalent to the "Hm" skeleton pattern.
    `java.lang.String` | `formatHour24MinuteSecond()` Returns localized format equivalent to the "Hms" skeleton pattern.
    `java.lang.String` | `formatMinuteSecond()` Returns localized format equivalent to the "ms" skeleton pattern.
    `java.lang.String` | `formatMonthAbbrev()` Returns localized format equivalent to the "MMM" skeleton pattern.
    `java.lang.String` | `formatMonthAbbrevDay()` Returns localized format equivalent to the "MMMd" skeleton pattern.
    `java.lang.String` | `formatMonthFull()` Returns localized format equivalent to the "MMMM" skeleton pattern.
    `java.lang.String` | `formatMonthFullDay()` Returns localized format equivalent to the "MMMMd" skeleton pattern.
    `java.lang.String` | `formatMonthFullWeekdayDay()` Returns localized format equivalent to the "MMMMEEEEd" skeleton pattern.
    `java.lang.String` | `formatMonthNumDay()` Returns localized format equivalent to the "Md" skeleton pattern.
    `java.lang.String` | `formatYear()` Returns localized format equivalent to the "y" skeleton pattern.
    `java.lang.String` | `formatYearMonthAbbrev()` Returns localized format equivalent to the "yMMM" skeleton pattern.
    `java.lang.String` | `formatYearMonthAbbrevDay()` Returns localized format equivalent to the "yMMMd" skeleton pattern.
    `java.lang.String` | `formatYearMonthFull()` Returns localized format equivalent to the "yMMMM" skeleton pattern.
    `java.lang.String` | `formatYearMonthFullDay()` Returns localized format equivalent to the "yMMMMd" skeleton pattern.
    `java.lang.String` | `formatYearMonthNum()` Returns localized format equivalent to the "yM" skeleton pattern.
    `java.lang.String` | `formatYearMonthNumDay()` Returns localized format equivalent to the "yMd" skeleton pattern.
    `java.lang.String` | `formatYearMonthWeekdayDay()` Returns localized format equivalent to the "yMMMEEEd" skeleton pattern.
    `java.lang.String` | `formatYearQuarterFull()` Returns localized format equivalent to the "yQQQQ" skeleton pattern.
    `java.lang.String` | `formatYearQuarterShort()` Returns localized format equivalent to the "yQ" skeleton pattern.
    `java.lang.String[]` | `monthsFull()` Returns an array of full month names.
    `java.lang.String[]` | `monthsFullStandalone()` Returns an array of month names for use in a stand-alone context.
    `java.lang.String[]` | `monthsNarrow()` Returns an array of the shortest abbreviations for months, typically a single character and not guaranteed to be unique.
    `java.lang.String[]` | `monthsNarrowStandalone()` Returns an array of the shortest abbreviations for months suitable for use in a stand-alone context, typically a single character and not guaranteed to be unique.
    `java.lang.String[]` | `monthsShort()` Returns an array of month abbreviations.
    `java.lang.String[]` | `monthsShortStandalone()` Returns an array of month abbreviations, suitable for use in a stand-alone context.
    `java.lang.String[]` | `quartersFull()` Returns an array of full quarter names.
    `java.lang.String[]` | `quartersShort()` Returns an array of abbreviations for quarters.
    `java.lang.String` | `timeFormat()` Returns a safe default time format.
    `java.lang.String` | `timeFormatFull()` Returns a "full" time format.
    `java.lang.String` | `timeFormatLong()` Returns a "long" time format.
    `java.lang.String` | `timeFormatMedium()` Returns a "medium" time format.
    `java.lang.String` | `timeFormatShort()` Returns a "short" time format.
    `java.lang.String[]` | `weekdaysFull()` Returns an array of the full names of weekdays.
    `java.lang.String[]` | `weekdaysFullStandalone()` Returns an array of the full names of weekdays, suitable for use in a stand-alone context.
    `java.lang.String[]` | `weekdaysNarrow()` Returns an array of the shortest abbreviations for weekdays, typically a single character and not guaranteed to be unique.
    `java.lang.String[]` | `weekdaysNarrowStandalone()` Returns an array of the shortest abbreviations for weekdays suitable for use in a stand-alone context, typically a single character and not guaranteed to be unique.
    `java.lang.String[]` | `weekdaysShort()` Returns an array of abbreviations for weekdays.
    `java.lang.String[]` | `weekdaysShortStandalone()` Returns an array of abbreviations for weekdays, suitable for use in a stand-alone context.
    `int` | `weekendEnd()` Returns the day which ends the weekend, as an index into the return value of `weekdaysFull()`.
    `int` | `weekendStart()` Returns the day which starts the weekend, as an index into the return value of `weekdaysFull()`.

- - ### Method Detail

    - #### ampms

          java.lang.String[] ampms()

      Returns array of strings containing abbreviations for Ante Meridiem and Post Meridiem.

    - #### dateFormat

          java.lang.String dateFormat()

      Returns a safe default date format.

    - #### dateFormatFull

          java.lang.String dateFormatFull()

      Returns a "full" date format.

    - #### dateFormatLong

          java.lang.String dateFormatLong()

      Returns a "long" date format.

    - #### dateFormatMedium

          java.lang.String dateFormatMedium()

      Returns a "medium" date format.

    - #### dateFormatShort

          java.lang.String dateFormatShort()

      Returns a "short" date format.

    - #### dateTime

          java.lang.String dateTime(java.lang.String timePattern,
                                    java.lang.String datePattern)

      Returns a date/time format from a date format pattern and a time format pattern, using the locale default joining.
      Parameters:
        `timePattern` - the time pattern String
        `datePattern` - the data pattern String

    - #### dateTimeFull

          java.lang.String dateTimeFull(java.lang.String timePattern,
                                        java.lang.String datePattern)

      Returns a date/time format from a date format pattern and a time format pattern, using "full" joining.
      Parameters:
        `timePattern` - the time pattern String
        `datePattern` - the data pattern String

    - #### dateTimeLong

          java.lang.String dateTimeLong(java.lang.String timePattern,
                                        java.lang.String datePattern)

      Returns a date/time format from a date format pattern and a time format pattern, using "full" joining.
      Parameters:
        `timePattern` - the time pattern String
        `datePattern` - the data pattern String

    - #### dateTimeMedium

          java.lang.String dateTimeMedium(java.lang.String timePattern,
                                          java.lang.String datePattern)

      Returns a date/time format from a date format pattern and a time format pattern, using "full" joining.
      Parameters:
        `timePattern` - the time pattern String
        `datePattern` - the data pattern String

    - #### dateTimeShort

          java.lang.String dateTimeShort(java.lang.String timePattern,
                                         java.lang.String datePattern)

      Returns a date/time format from a date format pattern and a time format pattern, using "full" joining.
      Parameters:
        `timePattern` - the time pattern String
        `datePattern` - the data pattern String

    - #### erasFull

          java.lang.String[] erasFull()

      Returns an array of the full era names.

    - #### erasShort

          java.lang.String[] erasShort()

      Returns abbreviations of the era names.

    - #### firstDayOfTheWeek

          int firstDayOfTheWeek()

      Returns the day which generally comes first in a weekly calendar view, as an index into the return value of `weekdaysFull()`.

    - #### formatDay

          java.lang.String formatDay()

      Returns localized format equivalent to the "d" skeleton pattern.

    - #### formatHour12Minute

          java.lang.String formatHour12Minute()

      Returns localized format equivalent to the "hm" skeleton pattern.

    - #### formatHour12MinuteSecond

          java.lang.String formatHour12MinuteSecond()

      Returns localized format equivalent to the "hms" skeleton pattern.

    - #### formatHour24Minute

          java.lang.String formatHour24Minute()

      Returns localized format equivalent to the "Hm" skeleton pattern.

    - #### formatHour24MinuteSecond

          java.lang.String formatHour24MinuteSecond()

      Returns localized format equivalent to the "Hms" skeleton pattern.

    - #### formatMinuteSecond

          java.lang.String formatMinuteSecond()

      Returns localized format equivalent to the "ms" skeleton pattern.

    - #### formatMonthAbbrev

          java.lang.String formatMonthAbbrev()

      Returns localized format equivalent to the "MMM" skeleton pattern.

    - #### formatMonthAbbrevDay

          java.lang.String formatMonthAbbrevDay()

      Returns localized format equivalent to the "MMMd" skeleton pattern.

    - #### formatMonthFull

          java.lang.String formatMonthFull()

      Returns localized format equivalent to the "MMMM" skeleton pattern.

    - #### formatMonthFullDay

          java.lang.String formatMonthFullDay()

      Returns localized format equivalent to the "MMMMd" skeleton pattern.

    - #### formatMonthFullWeekdayDay

          java.lang.String formatMonthFullWeekdayDay()

      Returns localized format equivalent to the "MMMMEEEEd" skeleton pattern.

    - #### formatMonthNumDay

          java.lang.String formatMonthNumDay()

      Returns localized format equivalent to the "Md" skeleton pattern.

    - #### formatYear

          java.lang.String formatYear()

      Returns localized format equivalent to the "y" skeleton pattern.

    - #### formatYearMonthAbbrev

          java.lang.String formatYearMonthAbbrev()

      Returns localized format equivalent to the "yMMM" skeleton pattern.

    - #### formatYearMonthAbbrevDay

          java.lang.String formatYearMonthAbbrevDay()

      Returns localized format equivalent to the "yMMMd" skeleton pattern.

    - #### formatYearMonthFull

          java.lang.String formatYearMonthFull()

      Returns localized format equivalent to the "yMMMM" skeleton pattern.

    - #### formatYearMonthFullDay

          java.lang.String formatYearMonthFullDay()

      Returns localized format equivalent to the "yMMMMd" skeleton pattern.

    - #### formatYearMonthNum

          java.lang.String formatYearMonthNum()

      Returns localized format equivalent to the "yM" skeleton pattern.

    - #### formatYearMonthNumDay

          java.lang.String formatYearMonthNumDay()

      Returns localized format equivalent to the "yMd" skeleton pattern.

    - #### formatYearMonthWeekdayDay

          java.lang.String formatYearMonthWeekdayDay()

      Returns localized format equivalent to the "yMMMEEEd" skeleton pattern.

    - #### formatYearQuarterFull

          java.lang.String formatYearQuarterFull()

      Returns localized format equivalent to the "yQQQQ" skeleton pattern.

    - #### formatYearQuarterShort

          java.lang.String formatYearQuarterShort()

      Returns localized format equivalent to the "yQ" skeleton pattern.

    - #### monthsFull

          java.lang.String[] monthsFull()

      Returns an array of full month names.

    - #### monthsFullStandalone

          java.lang.String[] monthsFullStandalone()

      Returns an array of month names for use in a stand-alone context.

    - #### monthsNarrow

          java.lang.String[] monthsNarrow()

      Returns an array of the shortest abbreviations for months, typically a single character and not guaranteed to be unique.

    - #### monthsNarrowStandalone

          java.lang.String[] monthsNarrowStandalone()

      Returns an array of the shortest abbreviations for months suitable for use in a stand-alone context, typically a single character and not guaranteed to be unique.

    - #### monthsShort

          java.lang.String[] monthsShort()

      Returns an array of month abbreviations.

    - #### monthsShortStandalone

          java.lang.String[] monthsShortStandalone()

      Returns an array of month abbreviations, suitable for use in a stand-alone context.

    - #### quartersFull

          java.lang.String[] quartersFull()

      Returns an array of full quarter names.

    - #### quartersShort

          java.lang.String[] quartersShort()

      Returns an array of abbreviations for quarters.

    - #### timeFormat

          java.lang.String timeFormat()

      Returns a safe default time format.

    - #### timeFormatFull

          java.lang.String timeFormatFull()

      Returns a "full" time format.

    - #### timeFormatLong

          java.lang.String timeFormatLong()

      Returns a "long" time format.

    - #### timeFormatMedium

          java.lang.String timeFormatMedium()

      Returns a "medium" time format.

    - #### timeFormatShort

          java.lang.String timeFormatShort()

      Returns a "short" time format.

    - #### weekdaysFull

          java.lang.String[] weekdaysFull()

      Returns an array of the full names of weekdays.

    - #### weekdaysFullStandalone

          java.lang.String[] weekdaysFullStandalone()

      Returns an array of the full names of weekdays, suitable for use in a stand-alone context.

    - #### weekdaysNarrow

          java.lang.String[] weekdaysNarrow()

      Returns an array of the shortest abbreviations for weekdays, typically a single character and not guaranteed to be unique.

    - #### weekdaysNarrowStandalone

          java.lang.String[] weekdaysNarrowStandalone()

      Returns an array of the shortest abbreviations for weekdays suitable for use in a stand-alone context, typically a single character and not guaranteed to be unique.

    - #### weekdaysShort

          java.lang.String[] weekdaysShort()

      Returns an array of abbreviations for weekdays.

    - #### weekdaysShortStandalone

          java.lang.String[] weekdaysShortStandalone()

      Returns an array of abbreviations for weekdays, suitable for use in a stand-alone context.

    - #### weekendEnd

          int weekendEnd()

      Returns the day which ends the weekend, as an index into the return value of `weekdaysFull()`.

      Note that this value may be numerically less than `weekendStart()` - for example, `weekendStart()` of 6 and `weekendEnd()` of 0 means Saturday and Sunday are the weekend.

    - #### weekendStart

          int weekendStart()

      Returns the day which starts the weekend, as an index into the return value of `weekdaysFull()`.